﻿using System;
using System.Data;
using MySql.Data.MySqlClient;
using MySql.Data.Types;


namespace ConsoleApplication1
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	class Class1
	{
		/// <summary>
		/// The main entry point for the application.
    
    private DataTable data;
    private MySqlDataAdapter da;
    private MySqlCommandBuilder cb;
    /// </summary>
		[STAThread]
		static void Main(string[] args)
		{
      string connStr = "server=localhost; database=test; pooling=false";
      MySqlConnection conn = new MySqlConnection( connStr );


      try 
      {
        conn.Open();

      }
      catch (MySqlException ex) 
      {
        Console.WriteLine("Error connecting to the server: " + ex.Message );
      }
      finally
      {
        MySqlCommand cmd = conn.CreateCommand();

        cmd.CommandText = "set names UTF8";
        cmd.ExecuteNonQuery();

        cmd.CommandText = "drop table if exists temp3";
        cmd.ExecuteNonQuery();

        cmd.CommandText = "create table if not exists temp3 (\n"+
          "query TEXT NOT NULL\n" +
          ") CHARACTER SET UTF8;";
        cmd.ExecuteNonQuery();

        cmd.CommandText = "show variables like '%char%'";
        MySqlDataReader m_reader = cmd.ExecuteReader();
        while (m_reader.Read())
        {
          Console.WriteLine(m_reader.GetString(0)+" "+m_reader.GetString(1));
        }
        m_reader.Close();
        // works fine
        cmd.CommandText = "insert into temp3 (query) VALUES (?query)";
        cmd.Parameters.Clear();
        cmd.Parameters.Add (new MySqlParameter ("?query", "abc"));
        cmd.ExecuteNonQuery();

        // doesn't work - all the chinese characters turn into ?
        cmd.Parameters.Clear();
        string qval = "澳大利亞";
        char x;
        x = qval[0]; // shows that each character is indeed the right unicode
        x = qval[1]; // character codes
        x = qval[2];
        x = qval[3];
        cmd.Parameters.Add (new MySqlParameter ("?query", qval));
        cmd.ExecuteNonQuery();

        cmd.CommandText = "insert into temp3 (query) VALUES ('澳大利亞')";
        cmd.ExecuteNonQuery();
      }
		}
	}
}
